DoItAll = DoItAll or {}

local function IsItemSavedByItemSaver(slot)
--d("[DoItAll]ItemSaver - bag: " .. tostring(slot.data.bagId) .. ", slot: " .. tostring(slot.data.slotIndex))
	if not DoItAll.Settings.GetRespectItemSaver() then return false end
	--local useISFilterSetSettings = DoItAll.Settings.GetUseISFilterSetChecks()
    if not ItemSaver_IsItemSaved then return false end
    --For backwards compatibility of older ItemSaver versions without item sets!
    local retVar = false
    --local setName
    --retVar, setName = ItemSaver_IsItemSaved(slot.data.bagId, slot.data.slotIndex)
    retVar = ItemSaver_IsItemSaved(slot.data.bagId, slot.data.slotIndex)
    --if useISFilterSetSettings and retVar and setName ~= nil then
        --if ItemSaver_GetFilters then
            --[[
                    return {
                        store = setData.filterStore,
                        deconstruction = setData.filterDeconstruction,
                        research = setData.filterResearch,
                        guildStore = setData.filterGuildStore,
                        mail = setData.filterMail,
                        trade = setData.filterTrade,
                    }
             ]]
            --local savedInfoArray = ItemSaver_GetFilters(setName)
            --if savedInfoArray ~= nil and savedInfoArray["deconstruction"] ~= nil then
                --Item is saved with set for deconstruction
                --retVar = savedInfoArray["deconstruction"]
            --end
        --end
    --end
    return retVar
end

--Is item saved by FCOItemSaver?
local function IsItemSavedByFCOItemSaver(slot)
--d("[DoItAll]FCOItemSaver - bag: " .. tostring(slot.data.bagId) .. ", slot: " .. tostring(slot.data.slotIndex))
	if not DoItAll.Settings.GetRespectItemSaver() then return false end
    local useFCOISPanelAntiSettings = DoItAll.Settings.GetUseFCOISFilterPanelChecks()

	if not FCOIsMarked and (not FCOIS or not FCOIS.IsMarked) then return false end
	local retVar = false

	--Is the new FCOIS DeconstructionSelectionHandler supported?
	if useFCOISPanelAntiSettings and DoItAll.FCOIS.deconstructionSelectionHandlerSupported then
--d(">Using FCOIS panel anti settings")
		--Are we inside the refinement panel? Then abort here directly
		if DoItAll.IsShowingRefinement() then
		--	Get the marked icons on the item that will be deconstructed
			local isAnyIconMarked, markedArray
			--FCOItemSaver version < 1.0
			if FCOIsMarked then
				isAnyIconMarked, markedArray = FCOIsMarked(GetItemInstanceId(slot.data.bagId, slot.data.slotIndex), -1)
			else
				--FCOItemSaver version >= 1.0
				isAnyIconMarked, markedArray = FCOIS.IsMarked(slot.data.bagId, slot.data.slotIndex, -1)
			end
--d(">> Refinement, marked: " .. tostring(isAnyIconMarked))
			return isAnyIconMarked
		else
			--Call the FCOItemSaver DeconstructionSelectionHandler
			--FCOIS.callDeconstructionSelectionHandler(bag, slot, echo, overrideChatOutput, suppressChatOutput, overrideAlert, suppressAlert, calledFromExternalAddon, panelId)
			--IMPORTANT: parameter "calledFromExternalAddon" MUST be set to true in order to let this function call work here !!!
			retVar = FCOIS.callDeconstructionSelectionHandler(slot.data.bagId, slot.data.slotIndex, false, false, true, false, true, true)
		end
    else
		--Use old checks
   		--	Check if any icon is marked on the item for deconstruction
		local isAnyIconMarked
		--FCOItemSaver version < 1.0
		if FCOIsMarked then
			isAnyIconMarked, _ = FCOIS.IsMarked(GetItemInstanceId(slot.data.bagId, slot.data.slotIndex), -1)
		else
			--FCOItemSaver version >= 1.0
			isAnyIconMarked, _ = FCOIS.IsMarked(slot.data.bagId, slot.data.slotIndex, -1)
		end
		retVar = isAnyIconMarked
    end
--d("<< [DoItAll-IsItemSavedByFCOIS] blocked: " .. tostring(retVar))
    return retVar
end

local function IsItemResearchable(slot)
	if not DoItAll.Settings.GetKeepResearchableItems() then return false end
	local raState = slot.data.researchAssistant or ""
	return raState == "researchable"
end

local function canBeMovedToBank(slot)
	-- Cannot be moved to bank
	local bagId = slot.data.bagId
	local slotIndex = slot.data.slotIndex
	if bagId == nil or slotIndex == nil then return true end
	if IsItemStolen(bagId, slotId) then return false end
	local itemLink = GetItemLink(bagId, slotId)
	if itemLink == nil or itemLink == "" then return true end
	if bagId == BAG_BACKPACK and GetItemLinkBindType(itemLink) == BIND_TYPE_ON_PICKUP_BACKPACK then return false end
end

DoItAll.ItemFilter = ZO_Object:Subclass()

function DoItAll.ItemFilter:New(ignoreResearchable)
--d("[DoItAll] Itemfilter - new")
	local obj = ZO_Object.New(self)
	obj.ignoreResearchable = ignoreResearchable
	return obj
end

function DoItAll.ItemFilter:Filter(slot, filterWhere)
	filterWhere = filterWhere or ""
	local isFilteredIS = IsItemSavedByItemSaver(slot)
	local isFilteredFCOIS = IsItemSavedByFCOItemSaver(slot)
	local isFilteredBank = false
	if filterWhere ~= nil and filterWhere ~= "" then
		if filterWhere == "BANK_DEPOSIT" then
			isFilteredBank = canBeMovedToBank(slot)
		end
	end
	local isFilteredReturn = isFilteredBank or isFilteredIS or isFilteredFCOIS
	if self.ignoreResearchable then
		isFilteredReturn = isFilteredReturn or IsItemResearchable(slot)
	end
--d("[DoItAll] Itemfilter - Filtered: " .. tostring(isFilteredIS) .. "/" .. tostring(isFilteredFCOIS) .. " , return: " .. tostring(isFilteredReturn))
	return isFilteredReturn
end
