DoItAll = DoItAll or {}

local function GetKeyStripName()
    local mode = SMITHING.mode
	local enchantMode = ENCHANTING.enchantingMode

    if mode == SMITHING_MODE_REFINMENT then
        return "Refine all"
    elseif mode == SMITHING_MODE_DECONSTRUCTION then
        return "Deconstr. all"
    end
    if enchantMode == ENCHANTING_MODE_EXTRACTION then
    	return "Extract all"
    end
    return "Extract all"
end

local function ShouldShow()
    local mode = SMITHING.mode
	local enchantMode = ENCHANTING.enchantingMode

    if mode == SMITHING_MODE_REFINMENT then
        return true
    elseif mode == SMITHING_MODE_DECONSTRUCTION then
        return true
    end
    if enchantMode == ENCHANTING_MODE_EXTRACTION then
    	return true
    end
    return false
end

local keystripDef = {
	name = function() return GetKeyStripName() end,
	keybind = "SC_BANK_ALL",
	callback = function() DoItAll.ExtractAll() end,
	alignment = KEYBIND_STRIP_ALIGN_LEFT,
	visible = function() return ShouldShow() end,
}

table.insert(SMITHING.keybindStripDescriptor, keystripDef)
table.insert(ENCHANTING.keybindStripDescriptor, keystripDef)

EVENT_MANAGER:RegisterForEvent("DoItAllExtraction", EVENT_CRAFTING_STATION_INTERACT, function(eventCode, TradeskillType , sameStation)
    --Supported crafting station?
    if TradeskillType ~= CRAFTING_TYPE_PROVISIONING and TradeskillType ~= CRAFTING_TYPE_ALCHEMY then
        --Remove the old keybind if there is still one activated
        if DoItAll.currentKeyStripDef ~= nil then
            KEYBIND_STRIP:RemoveKeybindButtonGroup(DoItAll.currentKeyStripDef)
        end
        --Add the keystrip def to the global vars so we can reach it from everywhere
        DoItAll.currentKeyStripDef = keystripDef
    end
end)
EVENT_MANAGER:RegisterForEvent("DoItAllExtraction", EVENT_END_CRAFTING_STATION_INTERACT, function()
    --Remove the old keybind if there is still one activated
    if DoItAll.currentKeyStripDef ~= nil then
        KEYBIND_STRIP:RemoveKeybindButtonGroup(DoItAll.currentKeyStripDef)
    end
    --Reset the last used one
    DoItAll.currentKeyStripDef = nil
end)

--[[ OLD
local function HookCraftingToolBarButton(button, newHandler)
  local existingFunction = button.m_object.m_buttonData.callback
  button.m_object.m_buttonData.callback = function(...)
    newHandler()
    existingFunction(...)
  end
end

local function PerhapsShowKeybindButton()
  if DoItAll.IsShowingExtraction() or DoItAll.IsShowingDeconstruction() or DoItAll.IsShowingRefinement() then
  	KEYBIND_STRIP:AddKeybindButtonGroup(keystripDef)
  end
end

HookCraftingToolBarButton(ZO_EnchantingTopLevelModeMenuBarButton2, function() KEYBIND_STRIP:AddKeybindButtonGroup(keystripDef) end)
HookCraftingToolBarButton(ZO_EnchantingTopLevelModeMenuBarButton1, function() KEYBIND_STRIP:RemoveKeybindButtonGroup(keystripDef) end)
HookCraftingToolBarButton(ZO_SmithingTopLevelModeMenuBarButton3, function() KEYBIND_STRIP:AddKeybindButtonGroup(keystripDef) end)
HookCraftingToolBarButton(ZO_SmithingTopLevelModeMenuBarButton1, function() KEYBIND_STRIP:AddKeybindButtonGroup(keystripDef) end)
HookCraftingToolBarButton(ZO_SmithingTopLevelModeMenuBarButton2, function() KEYBIND_STRIP:RemoveKeybindButtonGroup(keystripDef) end)
HookCraftingToolBarButton(ZO_SmithingTopLevelModeMenuBarButton4, function() KEYBIND_STRIP:RemoveKeybindButtonGroup(keystripDef) end)
HookCraftingToolBarButton(ZO_SmithingTopLevelModeMenuBarButton5, function() KEYBIND_STRIP:RemoveKeybindButtonGroup(keystripDef) end)

EVENT_MANAGER:RegisterForEvent("DoItAllExtraction", EVENT_ACTION_LAYER_POPPED, function() KEYBIND_STRIP:RemoveKeybindButtonGroup(keystripDef) end)
EVENT_MANAGER:RegisterForEvent("DoItAllExtraction", EVENT_ACTION_LAYER_PUSHED, PerhapsShowKeybindButton)
]]

